#include <gtest/gtest.h>
#include "CFixedPointNumber.h"
CFixedPointNumber my123=123;
CFixedPointNumber my199=199;
CFixedPointNumber my100=100;
CFixedPointNumber my1=1;
CFixedPointNumber mytest=482;
TEST(CFixedPointNumber, StoringGettingSettingAndDisplaying) {
    std::stringstream stream;
    stream<<my1;
    EXPECT_DOUBLE_EQ(stod(stream.str()),0.01);
    stream>>my1;
    EXPECT_DOUBLE_EQ(double(my1),0.01);
    std::string input2 = "56";
    std::istringstream stream2(input2);
    stream2>>my1;
    EXPECT_DOUBLE_EQ(double(my1),56);
    EXPECT_EQ(my1.getterlong(),5600);
    EXPECT_DOUBLE_EQ(double(my123),1.23);
    EXPECT_DOUBLE_EQ(double(my199),1.99);
    EXPECT_DOUBLE_EQ(double(my100),1);
    my1=2;
    EXPECT_DOUBLE_EQ(double(my1),0.02);
}

TEST(CFixedPointNumber, Divising) {
    EXPECT_DOUBLE_EQ(double(CFixedPointNumber(1)/CFixedPointNumber(1)),1);
    EXPECT_DOUBLE_EQ(double(CFixedPointNumber(10)/CFixedPointNumber(1)),10);
    EXPECT_DOUBLE_EQ(double(CFixedPointNumber(1)/CFixedPointNumber(10)),0.1);
}
TEST(CFixedPointNumber, Multiplying) {
    EXPECT_DOUBLE_EQ(double(CFixedPointNumber(10)*CFixedPointNumber(100)),0.1);
    EXPECT_DOUBLE_EQ(double(CFixedPointNumber(10).operator*(100)),0.1);
    EXPECT_DOUBLE_EQ(double(CFixedPointNumber(100)*CFixedPointNumber(100)),1);
    EXPECT_DOUBLE_EQ(double(mytest.mul(100)),4.82);
    EXPECT_DOUBLE_EQ(double(mytest.mul(10)),0.48);
}
TEST(CFixedPointNumber, AddingAndSubstracing) {
    EXPECT_DOUBLE_EQ(double(CFixedPointNumber(1)+CFixedPointNumber(10)),0.11);
    EXPECT_DOUBLE_EQ(double(CFixedPointNumber(1)-CFixedPointNumber(10)),-0.09);
    EXPECT_DOUBLE_EQ(double(mytest.add(1)),4.83);
    EXPECT_DOUBLE_EQ(double(mytest.add(10)),4.92);
    EXPECT_DOUBLE_EQ(double(mytest.diff(10)),4.72);
}
TEST(CFixedPointNumber, InaccurateMultiplying) {
    EXPECT_DOUBLE_EQ(double(CFixedPointNumber(1)*CFixedPointNumber(10)),0);
    EXPECT_DOUBLE_EQ(double(my1.mul(10)),0);
}
TEST(CFixedPointNumber, EQ) {
    EXPECT_TRUE(CFixedPointNumber(1)+CFixedPointNumber(10)==CFixedPointNumber(11));
    EXPECT_FALSE(CFixedPointNumber(1)+CFixedPointNumber(10)==CFixedPointNumber(94));
}
TEST(CFixedPointNumber, comp) {
    EXPECT_TRUE(CFixedPointNumber(1)<CFixedPointNumber(10));
    EXPECT_TRUE(operator<(CFixedPointNumber(1),(CFixedPointNumber(10))));
    EXPECT_FALSE(CFixedPointNumber(10)<CFixedPointNumber(10));
    EXPECT_FALSE(CFixedPointNumber(100)<CFixedPointNumber(10));
    EXPECT_FALSE(CFixedPointNumber(1)>CFixedPointNumber(10));
    EXPECT_FALSE(CFixedPointNumber(10)>CFixedPointNumber(10));
    EXPECT_TRUE(CFixedPointNumber(100)>CFixedPointNumber(10));    
}
TEST(CFixedPointNumber, counting) {
    EXPECT_EQ(my1.howmany(),5);
    CFixedPointNumber* my2=new CFixedPointNumber;
    EXPECT_EQ(my1.howmany(),6);
    delete my2;
    EXPECT_EQ(my1.howmany(),5);
}
int main() {
    testing::InitGoogleTest();
    return RUN_ALL_TESTS();
}
